local apenabled = 1

local function GetArtifactXP()
	local azeriteItemLocation = C_AzeriteItem.FindActiveAzeriteItem()
	if azeriteItemLocation then

		if not azeriteItemLocation:IsEquipmentSlot() then
			return
		end

		local currentLevel = C_AzeriteItem.GetPowerLevel(azeriteItemLocation)

		local v, m = C_AzeriteItem.GetAzeriteItemXPInfo(azeriteItemLocation)
		return v, m, currentLevel
	end
end

local function ShowAzerite(self)

	local appct = 0
	local value, max, level = GetArtifactXP()
	if value then

		if apenabled == 1 then
			self:Show()
		end

		appct = (value / max) * 100
		self.text:SetText(format("[Lv %d] %d/%d (%d%%)", level, value, max, appct))
		
	else
		self:Hide()		
	end

	self:SetValue(appct)
end

local apframe = CreateFrame("StatusBar", nil, UIParent)
apframe:SetSize(256, 32)
apframe:SetPoint("TOP")
apframe:SetBackdrop({bgFile = [[Interface\ChatFrame\ChatFrameBackground]]})
apframe:SetBackdropColor(0, 0, 0, 0.7)
apframe:SetStatusBarTexture([[Interface\Addons\AzeritePower\textures\Minimalist]])
apframe:SetStatusBarColor(0, 0.5, 1)

apframe:SetMinMaxValues(0, 100)

apframe.text = apframe:CreateFontString(nil,"ARTWORK",nil)
apframe.text:SetFont([[Interface\Addons\AzeritePower\RobotoCondensed-Bold.ttf]], 16, "OUTLINE")
apframe.text:SetPoint("CENTER")
apframe.text:SetJustifyH("MIDDLE")
apframe.text:SetJustifyV("MIDDLE")

apframe.text:SetTextColor(1,1,1,1)

apframe:RegisterEvent("AZERITE_ITEM_EXPERIENCE_CHANGED")
apframe:RegisterEvent("PLAYER_ENTERING_WORLD", "AZERITE_ITEM_EXPERIENCE_CHANGED")
apframe:RegisterEvent("PLAYER_EQUIPMENT_CHANGED")
apframe:RegisterEvent("ADDON_LOADED");

apframe:SetScript("OnEvent", function(self, event, ...)
	if event == "AZERITE_ITEM_EXPERIENCE_CHANGED" then
		ShowAzerite(self)
	end
	if event == "PLAYER_ENTERING_WORLD" then
		ShowAzerite(self)
	end

	if event == "PLAYER_EQUIPMENT_CHANGED" then
		ShowAzerite(self)
	end   
	
	if event == "ADDON_LOADED" then
		if AzeritePowerEnabled == nil then
			AzeritePowerEnabled = 1
		else
			apenabled = AzeritePowerEnabled
			ShowAzerite(self)
		end
	end
end);

local function AzeritePowerCommands(msg, editbox)
	if msg == "off" then
		  apenabled = 0
		  AzeritePowerEnabled = 0
	  	apframe:Hide()
		print("|cFF0000FFAzerite Power|cFFFFFFFF: Disabled!")
	elseif msg == "on" then
		  apenabled = 1
		  AzeritePowerEnabled = 1
	  	apframe:Show()
		print("|cFF0000FFAzerite Power|cFFFFFFFF: Enabled!");
	else
		print("|cFF0000FFAzerite Power|cFFFFFFFF: Syntax: /azp (off|on)");
	end 
end
  
SLASH_INAAZERITEPOWER1 = '/azp'

SlashCmdList["INAAZERITEPOWER"] = AzeritePowerCommands 

local hoaframe = CreateFrame("Frame", nil, apframe)
hoaframe:SetSize(32, 32)
hoaframe:SetPoint("LEFT", -32, 0)

local iconimage = hoaframe:CreateTexture(nil,"BACKGROUND")
iconimage:SetTexture(1869493)
hoaframe.texture = iconimage
iconimage:SetSize(32, 32)
iconimage:SetPoint("RIGHT")

hoaframe:Show()